#ifndef VGAPAINT_DRAW_H
#define VGAPAINT_DRAW_H

#include <a/types.h>

#include "vgapaint.h"

#ifdef	VGAPAINT_DRAW_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN extern
#define INIT(x)
#endif

enum VPAirbrushModes {
	VP_AIRBRUSH_CIRCLE = 0,
	VP_AIRBRUSH_SQUARE = 1,
	VP_AIRBRUSH_DIAMOND= 2,
	VP_AIRBRUSH_RSLASH = 3,
	VP_AIRBRUSH_LSLASH = 4,
};

struct VPAirbrushOpts {
	ulong	size;
	uchar	shape;
};

EXTERN struct VPPaintOpts {
	struct VPAirbrushOpts	airbrush;
} vpopts
#ifdef	VGAPAINT_DRAW_C
	={ 12,VP_AIRBRUSH_CIRCLE }
#endif
;

void	VPRequestAirbrushOpts(void);

#endif

