#include "version.h"
#include "copyrig2.h"

char last_build_string[]="Last build (" VERSION "): " __DATE__;

//char version_str[]="VGAPaint 386 v" VERSION " (Alpha 8) by Avery Lee";
char version_str[]="VGAPaint 386 V1.4 FINAL ["VERSION"] by Avery Lee";
						  
static char bozo_str[]=
{
0x52,0x6d,0x69,0x6d,0x7f,0x4e,0x25,0xa0,
0x69,0x63,0x77,0x28,0x7d,0x4f,0x24,0xe9,
0x67,0x6b,0x61,0x6c,0x30,0x76,0x07,0xc1,
0x51,0x63,0x6d,0x66,0x64,0x00,0x73,0xb8,
0x37,0x2c,0x24,0x28,0x51,0x44,0x36,0xe9,
0x72,0x67,0x24,0x71,0x7f,0x55,0x60,0xe4,
0x64,0x6e,0x61,0x7c,0x75,0x00,0x34,0xe8,
0x68,0x71,0x24,0x6b,0x7f,0x50,0x39,0xa0,
0x60,0x6c,0x60,0x02,0x7f,0x42,0x34,0xe1,
0x68,0x6c,0x24,0x69,0x30,0x46,0x32,0xe5,
0x72,0x6a,0x28,0x28,0x45,0x6e,0x0d,0xcf,
0x45,0x4b,0x42,0x41,0x55,0x64,0x60,0xe3,
0x6e,0x72,0x7d,0x26,0x1a,
0xFF,
};
//"Someone has modified VGAPaint 386.  Advise you delete this copy and\n"
//"obtain a fresh, UNMODIFIED copy.\n";

#include <string.h>
#include <a/types.h>

ulong rol(ulong);
#pragma aux rol="rol eax,1" parm [eax] modify exact [eax] value [eax];

ulong checksum(ulong *s,ulong cnt) {
	ulong checksum=0;
	do {
		checksum=rol(checksum^*s++);
	} while(--cnt);
	return checksum;
}

void check_for_bozo_alteration(void) {
	char encoder=0x01;
	char *s;
	uchar c;

/* first, check to see if some a-hole tried to steal my program by
   altering the version string. */

   	if (checksum((ulong *)version_str,3)!=0x3FC3F977) goto bozo;
	if (checksum((ulong *)&version_str[strlen(version_str)-12],3)!=0x2600C68B) goto bozo;
	return;

/* the bozo string is encrypted */

bozo:
	s=bozo_str;
	while((c=*s++)!=0xFF) {
//		printf("0x%02x,\n",c^encoder);
		putchar(c^encoder);
		encoder=_lrotl(encoder,1);
	};
	exit(100);
}

void print_copyright(void) {
	char c,*s=copyright_str;
	while(c=*s++) putchar(c^0xA5);
}


