#ifndef	VGAPAINT_ZONES_H
#define	VGAPAINT_ZONES_H

#include "tools.h"
#include "vgapaint.h"

#ifdef	VGAPAINT_ZONES_C
#define	EXTERN
#define	INIT(x)	=x
#else
#define	EXTERN	extern
#define	INIT(x)
#endif

extern struct BitMap vidbm;

EXTERN	struct BitMap *zonebm	INIT(&vidbm);

void	ZoneRefresh(struct ZoneRange *zr);
void	ZoneDraw(struct ZoneRange *zr,struct Zone *z,int ind);
void	ZoneErase(struct ZoneRange *zr,struct Zone *z,int ind);
void	ZoneInvert(struct Zone *z);
long	ZoneRangeAct(struct ZoneRange *zr,coord x,coord y);
void	ZoneHit(struct ZoneRange *zr,struct Zone *z,int index,coord x,coord y);
int	palette_coordToColor(coord x,coord y);
void	paletteHandler(struct ZoneRange *zr,struct Zone *z,coord x,coord y);
void	palette_pickColor(uchar color);
void	palette_pickHighColor(uchar color);
void	palette_redrawHandler(struct ZoneRange *zr);
void	toolSpecial1(struct ZoneRange *zr,struct Zone *z,int index,char frame);
void	contSpecial1(struct ZoneRange *zr,struct Zone *z,int index,char frame);
void	gridHandler(struct ZoneRange *zr,struct Zone *z,coord x,coord y);
void	clearHandler(struct ZoneRange *zr,struct Zone *z,coord x,coord y);
void	palshiftLeft(struct ZoneRange *zr,struct Zone *z,coord x,coord y);
void	palshiftRight(struct ZoneRange *zr,struct Zone *z,coord x,coord y);
boolean	rectInside(struct Rectangle *r,coord x,coord y);
int	rectSearch(struct Rectangle *r,coord x,coord y);
void	rectInvert(struct Rectangle *r);
void	rectInvert2(struct Rectangle *r,color c);
void	rectD3D(struct Rectangle *);
void	rectI3D(struct Rectangle *);

void	ShiftZoneSet(struct ZoneRange *zr,coord xo,coord yo);
void	ShiftRectangles(struct Rectangle *r,coord xo,coord yo);

void	ZoneRangeInit(struct ZoneRange *zr);

#undef	INIT
#undef	EXTERN

#endif
