#ifndef	VGAPAINT_ASMFUNC_H
#define	VGAPAINT_ASMFUNC_H

#include <a/types.h>

char	vid_detect(void);
char	cpu_detect(void);
ulong	cpu_speed(char);
#pragma aux cpu_speed parm [eax] modify exact [eax] value [eax];

void	asm_mouse_disable(void);
#pragma aux asm_mouse_disable modify exact nomemory [];
void	asm_mouse_enable(void);
#pragma aux asm_mouse_enable modify exact nomemory [];
void	asm_mouse_ptrfunc(void);
void	asm_mouse_ptrf2(void);

void	asm_2xblit_fwd(uchar *dst,ulong dstwidth,uchar *src,ulong srcwidth,ulong xs,ulong ys);
#pragma aux asm_2xblit_fwd parm [edi] [ebx] [esi] [edx] [ecx] [eax] modify exact [esi edi eax ebx ecx edx];
void	asm_4xblit_fwd(uchar *dst,ulong dstwidth,uchar *src,ulong srcwidth,ulong xs,ulong ys);
#pragma aux asm_4xblit_fwd parm [edi] [ebx] [esi] [edx] [ecx] [eax] modify exact [esi edi eax ebx ecx edx];
void	asm_8xblit_fwd(uchar *dst,ulong dstwidth,uchar *src,ulong srcwidth,ulong xs,ulong ys);
#pragma aux asm_8xblit_fwd parm [edi] [ebx] [esi] [edx] [ecx] [eax] modify exact [esi edi eax ebx ecx edx];
void	asm_16xblit_fwd(uchar *dst,ulong dstwidth,uchar *src,ulong srcwidth,ulong xs,ulong ys);
#pragma aux asm_16xblit_fwd parm [edi] [ebx] [esi] [edx] [ecx] [eax] modify exact [esi edi eax ebx ecx edx];

void	InstallExceptionHandlers(void);

void interrupt far asm_int08_handler(void);
void interrupt far asm_int09_handler(void);
void interrupt far asm_int0a_handler(void);
void interrupt far asm_int0b_handler(void);
void interrupt far asm_int0c_handler(void);
void interrupt far asm_int0d_handler(void);
void interrupt far asm_int0e_handler(void);
void interrupt far asm_int0f_handler(void);

void interrupt far CBS_IntRoutine(void);

void	init_timer2_counter(void);

// pragma to read timer 2, for speed
ushort	read_timer2(void);
#pragma aux read_timer2 =	\
	"mov al,80h","out 43h,al",	\
	"in al,42h","mov ah,al","in al,42h","xchg al,ah" value [ax] modify exact [ax];

void	byte_histogram(uchar *mem,ulong len,ulong *hmem);

#endif

